#
# hello.step.45.py
#
# receive and display step response
# hello.step.45.py serial_port
#
# Neil Gershenfeld
# CBA MIT 10/29/10
#
# (c) Massachusetts Institute of Technology 2010
# Permission granted for experimental and personal use;
# license for commercial sale available from MIT
#

from Tkinter import *
import serial

WINDOW = 600 # window size
eps = 0.5 # filter time constant
byte1 = 0
byte2 = 0

def read32():
   b1 = ord(ser.read())
   b2 = ord(ser.read())
   b3 = ord(ser.read())
   b4 = ord(ser.read())
   return 256*256*256*b1 + 256*256*b2 + 256*b3 + b4

def idle(parent,canvas):
   global eps, byte1, byte2
   #
   # idle routine
   #
   ser.flush()
   #
   # find framing 
   #



    #1

   canvas.itemconfigure("11txt",text="%d"%(read32()))
   canvas.itemconfigure("12txt",text="%d"%(read32()))
   canvas.itemconfigure("13txt",text="%d"%(read32()))
   canvas.itemconfigure("14txt",text="%d"%(read32()))
   canvas.itemconfigure("15txt",text="%d"%(read32()))

    #2

   canvas.itemconfigure("21txt",text="%d"%(read32()))
   canvas.itemconfigure("22txt",text="%d"%(read32()))
   canvas.itemconfigure("23txt",text="%d"%(read32()))
   canvas.itemconfigure("24txt",text="%d"%(read32()))
   canvas.itemconfigure("25txt",text="%d"%(read32()))

    #3

   canvas.itemconfigure("31txt",text="%d"%(read32()))
   canvas.itemconfigure("32txt",text="%d"%(read32()))
   canvas.itemconfigure("33txt",text="%d"%(read32()))
   canvas.itemconfigure("34txt",text="%d"%(read32()))
   canvas.itemconfigure("35txt",text="%d"%(read32()))

    #4

   canvas.itemconfigure("41txt",text="%d"%(read32()))
   canvas.itemconfigure("42txt",text="%d"%(read32()))
   canvas.itemconfigure("43txt",text="%d"%(read32()))
   canvas.itemconfigure("44txt",text="%d"%(read32()))
   canvas.itemconfigure("45txt",text="%d"%(read32()))


   canvas.update()
   parent.after_idle(idle,parent,canvas)

#
#  check command line arguments
#
if (len(sys.argv) != 2):
   print "command line: hello.step.45.py serial_port"
   sys.exit()
port = sys.argv[1]
#
# open serial port
#
ser = serial.Serial(port,9600)
ser.setDTR()
#
# set up GUI
#
root = Tk()
root.title('hello.step.45.py (q to exit)')
root.bind('q','exit')
canvas = Canvas(root, width=WINDOW, height=.75*WINDOW, background='white')
#
canvas.create_text(.1*WINDOW,.1*WINDOW,text="1",font=("Helvetica", 20),tags="clstxt",fill="#0000b0")

canvas.create_text(.1*WINDOW,.2*WINDOW,text="2",font=("Helvetica", 20),tags="11txt",fill="#0000b0")
canvas.create_text(.1*WINDOW,.3*WINDOW,text="2",font=("Helvetica", 20),tags="12txt",fill="#0000b0")
canvas.create_text(.1*WINDOW,.4*WINDOW,text="2",font=("Helvetica", 20),tags="13txt",fill="#0000b0")
canvas.create_text(.1*WINDOW,.5*WINDOW,text="2",font=("Helvetica", 20),tags="14txt",fill="#0000b0")
canvas.create_text(.1*WINDOW,.6*WINDOW,text="2",font=("Helvetica", 20),tags="15txt",fill="#0000b0")

canvas.create_text(.2*WINDOW,.2*WINDOW,text="2",font=("Helvetica", 20),tags="21txt",fill="#0000b0")
canvas.create_text(.2*WINDOW,.3*WINDOW,text="2",font=("Helvetica", 20),tags="22txt",fill="#0000b0")
canvas.create_text(.2*WINDOW,.4*WINDOW,text="2",font=("Helvetica", 20),tags="23txt",fill="#0000b0")
canvas.create_text(.2*WINDOW,.5*WINDOW,text="2",font=("Helvetica", 20),tags="24txt",fill="#0000b0")
canvas.create_text(.2*WINDOW,.6*WINDOW,text="2",font=("Helvetica", 20),tags="25txt",fill="#0000b0")

canvas.create_text(.3*WINDOW,.2*WINDOW,text="2",font=("Helvetica", 20),tags="31txt",fill="#0000b0")
canvas.create_text(.3*WINDOW,.3*WINDOW,text="2",font=("Helvetica", 20),tags="32txt",fill="#0000b0")
canvas.create_text(.3*WINDOW,.4*WINDOW,text="2",font=("Helvetica", 20),tags="33txt",fill="#0000b0")
canvas.create_text(.3*WINDOW,.5*WINDOW,text="2",font=("Helvetica", 20),tags="34txt",fill="#0000b0")
canvas.create_text(.3*WINDOW,.6*WINDOW,text="2",font=("Helvetica", 20),tags="35txt",fill="#0000b0")

canvas.create_text(.4*WINDOW,.2*WINDOW,text="2",font=("Helvetica", 20),tags="41txt",fill="#0000b0")
canvas.create_text(.4*WINDOW,.3*WINDOW,text="2",font=("Helvetica", 20),tags="42txt",fill="#0000b0")
canvas.create_text(.4*WINDOW,.4*WINDOW,text="2",font=("Helvetica", 20),tags="43txt",fill="#0000b0")
canvas.create_text(.4*WINDOW,.5*WINDOW,text="2",font=("Helvetica", 20),tags="44txt",fill="#0000b0")
canvas.create_text(.4*WINDOW,.6*WINDOW,text="2",font=("Helvetica", 20),tags="45txt",fill="#0000b0")



canvas.pack()
#
# start idle loop
#
root.after(100,idle,root,canvas)
root.mainloop()
